// Allied Tribes
// a random map for AOE3
// by RF_Gandalf

include "mercenaries.xs";

void main(void)
{  
   // Text
   rmSetStatusText("",0.01);

// Set up for variables
   string baseType = "";
   string centerTerrain = "";
   string pondType = "";
   string cliffType = "";
   string forestType = "";
   string treeType = "";
   string deerType = "";
   string deer2Type = "";
   string sheepType = "";
   string centerHerdType = "";

// Set up for natives to appear on the map
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;
   int subCiv4=-1;
   int subCiv5=-1;
   int subCiv6=-1;
   int subCiv7=-1;
   int subCiv8=-1;
   int subCiv9=-1;
   int subCiv10=-1;
   int subCiv11=-1;

   if (rmAllocateSubCivs(12) == true)
   {
	subCiv0=rmGetCivID("Comanche");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Comanche");

	subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

	subCiv2=rmGetCivID("Aztecs");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Aztecs");

	subCiv3=rmGetCivID("Maya");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Maya");

	subCiv4=rmGetCivID("Lakota");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Lakota");

	subCiv5=rmGetCivID("Nootka");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Nootka");

	subCiv6=rmGetCivID("Cherokee");
      if (subCiv6 >= 0)
         rmSetSubCiv(6, "Cherokee");

	subCiv7=rmGetCivID("Cree");
      if (subCiv7 >= 0)
         rmSetSubCiv(7, "Cree");

	subCiv8=rmGetCivID("Tupi");
      if (subCiv8 >= 0)
         rmSetSubCiv(8, "Tupi");

	subCiv9=rmGetCivID("Caribs");
      if (subCiv9 >= 0)
         rmSetSubCiv(9, "Caribs");

	subCiv10=rmGetCivID("Seminoles");
      if (subCiv10 >= 0)
         rmSetSubCiv(10, "Seminoles");

	subCiv11=rmGetCivID("Incas");
      if (subCiv11 >= 0)
         rmSetSubCiv(11, "Incas"); 
	}

// Pick pattern for trees, terrain, etc.
   int patternChance = -1;
   patternChance = rmRandInt(1, 18);
   int variantChance = -1;
   variantChance = rmRandInt(1, 2);
   int nativePattern = -1;
   int sheepChance = -1;
   sheepChance = rmRandInt(1, 2);
   int featureChance = -1;
   int makeCliffs = -1; 
   int cliffVariety= -1;
   cliffVariety = rmRandInt(1,5);
   int makePond = -1;
   int centerMt = -1;
   int vultures = -1;
   int eagles = -1;
   int plainsMap = -1;
   int hillTrees = -1;
   int placeBerries = 1;
   
// Picks the map size
   int playerTiles=14000;
   if (cNumberNonGaiaPlayers > 6)
	playerTiles = 11000;
   else if (cNumberNonGaiaPlayers > 3)
	playerTiles = 12000;
   if (cNumberNonGaiaPlayers == 3)
	playerTiles = 13000;

   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

// Elevation
   rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
   rmSetMapElevationHeightBlend(1);
   rmSetSeaLevel(0.0);
	
// Pick default terrain, water, map types

   if (patternChance == 1) // bayou
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("bayou");
      rmSetMapType("grass");
      rmSetLightingSet("bayou");

      baseType = "bayou_grass";
	forestType = "bayou swamp forest";
      makeCliffs = 0;
      makePond = 1;
      pondType = "bayou";
	treeType = "TreeBayou";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(0, 2);
	eagles = 1;
      variantChance = 2; 
   }
   else if (patternChance == 2) // carolina
   {
      rmSetSeaType("atlantic coast");
      rmSetMapType("carolina");
      rmSetMapType("grass");
      rmSetLightingSet("carolina");

      baseType = "carolina_grass";
	forestType = "carolina pine forest";
      makeCliffs = 2;
      cliffType = "Carolina Inland";
	makePond = 0;
	treeType = "TreeCarolinaGrass";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(1, 3);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   else if (patternChance == 3) // NE
   {   
      rmSetSeaType("new england coast");
	rmSetMapType("newEngland");
	rmSetMapType("grass");
	rmSetLightingSet("new england");

      baseType = "newengland_grass";
	forestType = "new england forest";
      makeCliffs = 1;
      cliffType = "New England";
      makePond = 1;
	pondType = "new england lake";
	treeType = "TreeNewEngland";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";         
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
	featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(2, 5);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   else if (patternChance == 4) // great lakes
   {
      if (variantChance == 1 )
         rmSetSeaType("hudson bay");
      else
	   rmSetSeaType("new england coast");
      rmSetMapType("greatlakes");
      rmSetMapType("grass");
      rmSetLightingSet("Great Lakes");

      baseType = "greatlakes_grass";
	forestType = "great lakes forest";
      makeCliffs = 2;
      cliffType = "New England";
      makePond = 1;
      pondType = "great lakes";
	treeType = "TreeGreatLakes";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";        
	}   
      sheepType = "sheep";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(3, 7);
      hillTrees = 1;
   }
   else if (patternChance == 5) // great lakes winter
   {
      rmSetSeaType("great lakes ice");
      rmSetMapType("greatlakes");
      rmSetMapType("snow");
      rmSetLightingSet("Great Lakes Winter");

      baseType = "greatlakes_snow";
	forestType = "great lakes forest snow";
      makeCliffs = 0;
      makePond = 1;
      pondType = "great lakes ice";
	treeType = "TreeGreatLakesSnow";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "bison";
         centerHerdType = "moose";       
	}      
      sheepType = "sheep";
      placeBerries = 0;
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(3, 7);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   else if (patternChance == 6) // saguenay
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("saguenay");
      rmSetMapType("grass");
      rmSetLightingSet("saguenay");

      baseType = "saguenay grass";
	forestType = "saguenay forest";
      makeCliffs = 0;
      makePond = 1;
      pondType = "saguenay lake";
	treeType = "TreeSaguenay";
      if (variantChance == 1 )
	{
         deerType = "caribou";
         deer2Type = "moose";
         centerHerdType = "caribou";
	}
      else 
	{     
         deerType = "caribou";
         deer2Type = "caribou";
         centerHerdType = "moose";       
	}
      sheepType = "sheep";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(3, 7);
   }
   else if (patternChance == 7) // yukon
   {
      rmSetSeaType("great lakes ice");
      rmSetMapType("yukon");
      rmSetMapType("snow");
      rmSetLightingSet("yukon");

      baseType = "yukon snow";
	forestType = "yukon snow forest";
      makeCliffs = 2;
      cliffType = "rocky mountain2";
      makePond = 0;
	centerMt = 1;
      centerTerrain = "yukon snow";
	treeType = "TreeYukon";
      if (variantChance == 1 )
	{
         deerType = "caribou";
         deer2Type = "muskOx";
         centerHerdType = "caribou";
	}
      else 
	{     
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";       
	}
      sheepChance = 0;
      placeBerries = 0;
      featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(5, 7);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   else if (patternChance == 8) // rockies
   {
      rmSetSeaType("great lakes");
      rmSetMapType("rockies");
      rmSetMapType("snow");
      rmSetLightingSet("rockies");

      baseType = "rockies_grass";
	forestType = "rockies forest";
      makeCliffs = 0;
      cliffType = "rocky mountain2";
      makePond = 0;
      centerMt = 1;
      centerTerrain = "rockies_snow";
	treeType = "TreeRockies";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "bighornsheep";
	}
      else 
	{     
         deerType = "elk";
         deer2Type = "elk";
         centerHerdType = "bighornsheep";
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(6, 10);
	eagles = 1;
      hillTrees = 1;
   }
   else if (patternChance == 9) // great plains 1
   {
      rmSetSeaType("new england coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
      rmSetLightingSet("great plains");
       
      baseType = "great plains grass"; 
	forestType = "great plains forest";
      makeCliffs = 2;
      cliffType = "Great Plains";
      makePond = 1;
      pondType = "great plains pond";
	treeType = "TreeGreatPlains";
      if (variantChance == 1 )
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(6, 10);
      vultures = 1;
      plainsMap = 1;
   }
   else if (patternChance == 10) // great plains 2
   {
      rmSetSeaType("new england coast");
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
      rmSetLightingSet("great plains");
       
      baseType = "great plains drygrass";
	forestType = "great plains forest";
      makeCliffs = 2;
      cliffType = "Great Plains";
      makePond = 1;
      pondType = "great plains pond";
	treeType = "TreeGreatPlains";
      if (variantChance == 1 )
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(6, 10);
      vultures = 1;
      plainsMap = 1;
   }
   else if (patternChance == 11) // texas grass
   {   
      rmSetSeaType("new england coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
      rmSetLightingSet("texas");

      baseType = "texas_grass";
	forestType = "texas forest";
      makeCliffs = 1;
      cliffType = "Texas Grass";
      makePond = 1;
	pondType = "texas pond";
	treeType = "TreeTexas";
      if (variantChance == 1 )
	{
         deerType = "bison";
         deer2Type = "deer";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
	featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(9, 11);
      vultures = 1;
   }
   else if (patternChance == 12) // texas desert
   {   
      rmSetSeaType("new england coast");
      rmSetMapType("texas");
	rmSetMapType("grass");
      rmSetLightingSet("texas");

      baseType = "texas_grass";
	centerTerrain = "texas\ground4_tex";
	forestType = "texas forest dirt";
      makeCliffs = 1;
      cliffType = "Texas";
      makePond = 0;
	treeType = "TreeTexasDirt";
      if (variantChance == 1 )
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "pronghorn";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
	featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(10, 12);
      vultures = 1;
   }
   else if (patternChance == 13) // sonora
   {   
      rmSetSeaType("Atlantic Coast");
      rmSetMapType("sonora");
	rmSetMapType("grass");
      rmSetLightingSet("sonora");

      baseType = "sonora_dirt";
	forestType = "sonora forest";
      makeCliffs = 1;
      cliffType = "Sonora";
      cliffVariety = 6;
      makePond = 0;
	treeType = "TreeSonora";
      if (variantChance == 1 )
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
      placeBerries = 0;
      featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(12, 13);
      vultures = 1;
   }
   else if (patternChance == 14) // yucatan
   {
      rmSetSeaType("yucatan Coast");
      rmSetMapType("yucatan");
      rmSetMapType("tropical");
      rmSetLightingSet("yucatan");
     
      baseType = "yucatan_grass";
	forestType = "yucatan forest";
      makeCliffs = 1;
      cliffType = "Amazon";
      makePond = 1;
      pondType = "Amazon River Basin";
	treeType = "TreeYucatan";
      if (variantChance == 1 )
      {
         deerType = "tapir";
         deer2Type = "capybara";
         centerHerdType = "turkey";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "turkey";
         centerHerdType = "tapir";
	}
      sheepChance = 0;
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(13, 14);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   else if (patternChance == 15) // caribbean
   {
      rmSetSeaType("caribbean coast");
      rmSetMapType("caribbean");
      rmSetMapType("grass");
      rmSetLightingSet("caribbean");
     
      baseType = "caribbean grass";
	forestType = "caribbean palm forest";
      makeCliffs = 0;
      makePond = 1;
      pondType = "Amazon River Basin";
	treeType = "TreeCaribbean";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "tapir";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "tapir";
         centerHerdType = "deer";
	}
      sheepChance = 2;
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(14, 15);
   }
   else if (patternChance == 16) // amazon
   {
      rmSetSeaType("yucatan coast");
      rmSetMapType("amazonia");
      rmSetMapType("grass");
      rmSetLightingSet("amazon");
     
      baseType = "amazon grass";
	forestType = "amazon rain forest";
      makeCliffs = 2;
      cliffType = "Amazon";
      makePond = 1;
      pondType = "Amazon River Basin";
	treeType = "TreeAmazon";
      if (variantChance == 1 )
      {
         deerType = "tapir";
         deer2Type = "tapir";
         centerHerdType = "capybara";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "tapir";
         centerHerdType = "capybara";
	}
      sheepChance = 0;
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(15, 17);
   }
   else if (patternChance == 17) // pampas
   {
      rmSetSeaType("yucatan coast");
      rmSetMapType("pampas");
      rmSetMapType("grass");
      rmSetLightingSet("pampas");

      baseType = "pampas_dirt";
	forestType = "pampas forest";
      makeCliffs = 0;
      makePond = 0;
	treeType = "TreePampas";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      featureChance = rmRandInt(1, 2);
	nativePattern = rmRandInt(15, 17);
      vultures = 1;
      eagles = 1;
   }
   else if (patternChance == 18) // patagonia
   {
      rmSetSeaType("hudson bay");
      rmSetMapType("patagonia");
      rmSetMapType("grass");
      rmSetLightingSet("patagonia");

      baseType = "patagonia_grass";
	forestType = "patagonia forest";
      makeCliffs = 1;
      cliffType = "Patagonia";
      makePond = 1;
      pondType = "hudson bay";
	treeType = "TreePatagoniaDirt";
      if (variantChance == 1 )
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
      featureChance = rmRandInt(1, 3);
	nativePattern = rmRandInt(15, 17);
      if (variantChance == 1 )
         hillTrees = 1;
   }
   
   rmSetBaseTerrainMix(baseType);
   rmTerrainInitialize("yukon\ground1_yuk", 1);
   rmSetMapType("land");
   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(2.0);

// Precipitation
   if (patternChance == 16) // amazon
      rmSetGlobalRain( 0.7 );
   if (patternChance == 7) // yukon
      rmSetGlobalSnow( 0.7 );
   if (patternChance == 5) // great lakes winter
      rmSetGlobalSnow( 0.7 );
   
   chooseMercs();

// Define some classes.
   int classPlayer=rmDefineClass("player");
   int lakeClass=rmDefineClass("lake");
   rmDefineClass("classHill");
   rmDefineClass("classPatch");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("classCliff");
   rmDefineClass("nuggets");
   rmDefineClass("center");
   rmDefineClass("socketClass");
   int classHuntable=rmDefineClass("huntableFood");   
   int classHerdable=rmDefineClass("herdableFood"); 
   int canyon=rmDefineClass("canyon");

   // Text
   rmSetStatusText("",0.10);

// -------------Define constraints
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int bisonEdgeConstraint=rmCreateBoxConstraint("bison edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
   int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 70.0);

   // Cardinal Directions
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 20.0);
   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

   // Nature avoidance
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
   int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidSheep=rmCreateClassDistanceConstraint("sheep avoids sheep etc", rmClassID("herdableFood"), 45.0);
   int huntableConstraint=rmCreateClassDistanceConstraint("huntable constraint", rmClassID("huntableFood"), 35.0);
   int forestsAvoidBison=rmCreateClassDistanceConstraint("forest avoids bison", rmClassID("huntableFood"), 15.0);
   int avoidDucks=rmCreateTypeDistanceConstraint("avoids ducks", "DuckFamily", 50.0);

   // Avoid impassable land, certain features
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
   int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
   int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 8.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
   int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water mid-longer", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water a little more", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 30.0);
   int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
   int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
   int nearShore=rmCreateTerrainMaxDistanceConstraint("tree v. water", "land", true, 14.0);
   int rockVsLand = rmCreateTerrainDistanceConstraint("rock v. land", "land", true, 2.0);
   
   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);
   int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 7.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 60.0);
   int avoidNativesShort=rmCreateClassDistanceConstraint("stuff avoids natives shorter", rmClassID("natives"), 25.0);
   int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 40.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
   int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
   int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 12.0);

   // New extra stuff for water spawn point avoidance.
   int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
   int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 70);
   int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

// End of constraints -----------------------------------:)

// Set up for axis and player side
   int axisChance = -1;
   axisChance = rmRandInt(1, 2);
   
   int playerSide = -1;
   playerSide = rmRandInt(1, 2);

   int positionChance = -1;
   positionChance = rmRandInt(1, 2);

   int setupChance = -1;
   setupChance = rmRandInt(1, 2);

// Set up player starting locations

if (cNumberNonGaiaPlayers == 2)
{
   if (setupChance == 1) // centered opposite
   {
        if (axisChance == 1)
        {
          if (playerSide == 1)
          {
	  	rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
          rmSetPlacementSection(0.20, 0.30);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.70, 0.80);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        }
        else if (axisChance == 2)
        {
	    if (playerSide == 1)
          {
		rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
	    rmSetPlacementSection(0.43, 0.57);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.93, 0.07);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        }
   }
   else if (setupChance == 2) // offcenter opposite
   {
      if (positionChance == 1)
      { 
         if (playerSide == 1)
         {  
		rmPlacePlayer(1, 0.2, 0.2);
		rmPlacePlayer(2, 0.8, 0.8);
	   }
         else if (playerSide == 2)
         {
		rmPlacePlayer(1, 0.8, 0.8);
		rmPlacePlayer(2, 0.2, 0.2);
         }
      }  
      else if (positionChance == 2)
      {
         if (playerSide == 1)
         {
		rmPlacePlayer(1, 0.2, 0.8);
		rmPlacePlayer(2, 0.8, 0.2);
	   }
	   else if (playerSide == 2)
         {     
		rmPlacePlayer(1, 0.8, 0.2);
		rmPlacePlayer(2, 0.2, 0.8);
	   }
      }
   }
}   
else if (cNumberNonGaiaPlayers > 2)
{ 
   if (cNumberTeams == 2)
   {
      if (cNumberPlayers == 4) // 2 teams, 4 players 
      {
        if (axisChance == 1)
        {
          if (playerSide == 1)
          {
	  	rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
          rmSetPlacementSection(0.21, 0.29);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.71, 0.79);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        }
        else if (axisChance == 2)
        {
	    if (playerSide == 1)
          {
		rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
	    rmSetPlacementSection(0.46, 0.54);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.96, 0.04);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        } 
      }
      else if (cNumberPlayers > 4)  // for 2 teams, over 4 players
      {
        if (axisChance == 1)
        {
          if (playerSide == 1)
          {
	  	rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
          rmSetPlacementSection(0.15, 0.35);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.65, 0.85);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        }
        else if (axisChance == 2)
        {
	    if (playerSide == 1)
          {
		rmSetPlacementTeam(0);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(1);
	    }
	    rmSetPlacementSection(0.40, 0.60);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);

	    if (playerSide == 1)
          {
		rmSetPlacementTeam(1);
	    }
          else if (playerSide == 2)
	    {
		rmSetPlacementTeam(0);
	    }
	    rmSetPlacementSection(0.90, 0.10);
	    rmPlacePlayersCircular(0.39, 0.41, 0.0);
        }
      }
      else  // for 3 players, 2 teams?
      {
	   rmPlacePlayersCircular(0.39, 0.41, 0.0);
      }
   }
   else  // for FFA or over 2 teams
   {
	   rmPlacePlayersCircular(0.40, 0.42, 0.0);
   }
}

   // Text
   rmSetStatusText("",0.20);
	
// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, baseType);
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();

// Central features & patches, per map or variant
   // Center area
   int centerArea=rmCreateArea("TheCenter");
   rmSetAreaSize(centerArea, 0.1, 0.1);
   rmSetAreaLocation(centerArea, 0.45, 0.45);
   rmAddAreaToClass(centerArea, rmClassID("center")); 

   // Texas desert
   int nativeNumber = rmRandInt(2,5);
   if (patternChance == 12)
   {
	   nativeNumber = rmRandInt(2,5);
         int desertID = rmCreateArea("desert");
         rmSetAreaLocation(desertID, 0.5, 0.5); 
         rmSetAreaWarnFailure(desertID, false);
         rmSetAreaSize(desertID, 0.35, 0.37);
         rmSetAreaCoherence(desertID, 0.1);
         rmSetAreaTerrainType(desertID, "texas\ground4_tex");
         rmAddAreaTerrainLayer(desertID, "texas\ground1_tex", 0, 4);
         rmAddAreaTerrainLayer(desertID, "texas\ground2_tex", 4, 8);
         rmAddAreaTerrainLayer(desertID, "texas\ground3_tex", 8, 12);
         rmSetAreaMix(desertID, "texas_dirt");
         rmBuildArea(desertID);
   }

   // Mt for Yukon, Rockies
   if (centerMt == 1)
   {
         int snowPatchID = rmCreateArea("snow patch"); 
         rmAddAreaToClass(snowPatchID, rmClassID("classHill"));
         rmAddAreaToClass(snowPatchID, rmClassID("classPatch"));
         rmSetAreaLocation(snowPatchID, 0.5, 0.5); 
         rmSetAreaWarnFailure(snowPatchID, false);
         rmSetAreaSize(snowPatchID, 0.039, 0.039);
         rmSetAreaCoherence(snowPatchID, 0.8);
         rmSetAreaMix(snowPatchID, centerTerrain);
         rmSetAreaElevationVariation(snowPatchID, 2.0);
         rmSetAreaBaseHeight(snowPatchID, 10.0);
         rmSetAreaElevationPersistence(snowPatchID, 0.7); 
         rmBuildArea(snowPatchID); 
   }

   // Center pond
   if (variantChance == 2)
   {       
      if (makePond == 1)
      {
         nativeNumber = 2;
	   int smalllakeID=rmCreateArea("small lake");
	   rmSetAreaSize(smalllakeID, rmAreaTilesToFraction(700), rmAreaTilesToFraction(750));
         rmSetAreaWaterType(smalllakeID, pondType);
         rmSetAreaBaseHeight(smalllakeID, 0.0);
         rmSetAreaMinBlobs(smalllakeID, 2);
         rmSetAreaMaxBlobs(smalllakeID, 3);
         rmSetAreaMinBlobDistance(smalllakeID, 6.0);
         rmSetAreaMaxBlobDistance(smalllakeID, 10.0);
         rmAddAreaToClass(smalllakeID, lakeClass);
         rmAddAreaConstraint(smalllakeID, playerConstraint);
         rmAddAreaConstraint(smalllakeID, avoidTradeRoute);
         rmSetAreaLocation(smalllakeID, 0.5, 0.5);
         rmSetAreaCoherence(smalllakeID, 0.7);
         rmSetAreaWarnFailure(smalllakeID, false);
         rmBuildArea(smalllakeID);
      }
   }

   // Dirt patches for Sonora
   if (patternChance == 13)
   {
	for (i=0; <10)
      {
		int dirtPatch=rmCreateArea("open dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatch, false);
		rmSetAreaSize(dirtPatch, rmAreaTilesToFraction(160), rmAreaTilesToFraction(250));
		rmSetAreaTerrainType(dirtPatch, "sonora\ground7_son");
		rmAddAreaToClass(dirtPatch, rmClassID("classPatch"));
		rmSetAreaMinBlobs(dirtPatch, 1);
		rmSetAreaMaxBlobs(dirtPatch, 5);
		rmSetAreaMinBlobDistance(dirtPatch, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatch, 40.0);
		rmSetAreaCoherence(dirtPatch, 0.0);
		rmSetAreaSmoothDistance(dirtPatch, 10);
		rmAddAreaConstraint(dirtPatch, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatch, patchConstraint);
		rmBuildArea(dirtPatch); 
      }
   }

   // Text
   rmSetStatusText("",0.30);

// Trade Routes
   // first route
   int tradeRouteID = rmCreateTradeRoute();
   if (axisChance == 1) 
   {	
	rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.85);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.7, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.7, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.15);
   }
   else 
   {	
	rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.52);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.7);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.85, 0.52);
   }
   bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");

   if(placedTradeRoute == false)
	rmEchoError("Failed to place trade route #1");

   // second route
   int tradeRouteID2 = rmCreateTradeRoute();
   if (axisChance == 1) 
   {
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.48, 0.15);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.3, 0.45);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.3, 0.55);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.48, 0.85);
   }
   else
   {
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.15, 0.48);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.40, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.60, 0.3);
	rmAddTradeRouteWaypoint(tradeRouteID2, 0.85, 0.48);
   }	
   bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");

   if(placedTradeRoute2 == false)
	rmEchoError("Failed to place trade route #2");

   // Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 7.0);

   // add the meeting poles along the trade route.
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
   vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.19);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.81);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.81);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.5);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.19);
   rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

   //Text
   rmSetStatusText("",0.35);

// Starting TCs and units 		
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);

   int startingTCID= rmCreateObjectDef("startingTC");
   rmAddObjectDefConstraint(startingTCID, avoidAll);
   rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);                 
   if ( rmGetNomadStart())
   {
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
   }

   for(i=0; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // Text
   rmSetStatusText("",0.40);

// NATIVE AMERICANS
   // Village A 
   int villageAID = -1;
   int villageType = rmRandInt(1,2);

//   nativePattern = 15;     // testing for all villages

   if (nativePattern == 0)
   {
 	villageAID = rmCreateGrouping("village A", "double seminole village "+villageType);
   }

   if (nativePattern == 1)
   {
 	villageAID = rmCreateGrouping("village A", "double seminole village "+villageType);
   }

   if (nativePattern == 2)
   {
 	villageAID = rmCreateGrouping("village A", "double seminole village "+villageType);
   }

   if (nativePattern == 3)
   {
	villageAID = rmCreateGrouping("village A", "double cree village "+villageType);
   }

   if (nativePattern == 4)
   {
	villageAID = rmCreateGrouping("village A", "double iroquois village "+villageType);
   }

   if (nativePattern == 5)
   {
      villageAID = rmCreateGrouping("village A", "double nootka village "+villageType);
   }

   if (nativePattern == 6)
   {
      villageAID = rmCreateGrouping("village A", "double nootka village "+villageType);
   }

   if (nativePattern == 7)
   {
      villageAID = rmCreateGrouping("village A", "double nootka village "+villageType);
   }

   if (nativePattern == 8)
   {
      villageAID = rmCreateGrouping("village A", "double nootka village "+villageType);
   }

   if (nativePattern == 9)
   {
	villageAID = rmCreateGrouping("village A", "double cree village "+villageType);
   }

   if (nativePattern == 10)
   {
	villageAID = rmCreateGrouping("village A", "double cherokee village "+villageType);
   }

   if (nativePattern == 11)
   {
 	villageAID = rmCreateGrouping("village A", "double seminole village "+villageType);
   }

   if (nativePattern == 12)
   {
 	villageAID = rmCreateGrouping("village A", "double aztec village "+villageType);
   }

   if (nativePattern == 13)
   {
 	villageAID = rmCreateGrouping("village A", "double aztec village "+villageType);
   }

   if (nativePattern == 14)
   {
 	villageAID = rmCreateGrouping("village A", "double aztec village "+villageType);
   }

   if (nativePattern == 15)
   {

	villageAID = rmCreateGrouping("village A", "double tupi village "+villageType);
   }

   if (nativePattern == 16)
   {
	villageAID = rmCreateGrouping("village A", "double inca village "+villageType);
   }

   if (nativePattern == 17)
   {
	villageAID = rmCreateGrouping("village A", "double inca village "+villageType);
   }

   rmSetGroupingMinDistance(villageAID, 25.0);
   rmSetGroupingMaxDistance(villageAID, 60.0);
   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidImportantItem);
   rmAddGroupingConstraint(villageAID, avoidNativesShort);

   // Village B
   int villageBID = -1;	
   villageType = rmRandInt(1,2);

   if (nativePattern == 0)
   {
	villageBID = rmCreateGrouping("village B", "double cherokee village "+villageType);
   }

   if (nativePattern == 1)
   {
	villageBID = rmCreateGrouping("village B", "double cherokee village "+villageType);
   }

   if (nativePattern == 2)
   {
	villageBID = rmCreateGrouping("village B", "double cherokee village "+villageType);
   }

   if (nativePattern == 3)
   {
	villageBID = rmCreateGrouping("village B", "double cherokee village "+villageType);
   }

   if (nativePattern == 4)
   {
	villageBID = rmCreateGrouping("village B", "double cherokee village "+villageType);
   }

   if (nativePattern == 5)
   {
	villageBID = rmCreateGrouping("village B", "double cree village "+villageType);
   }

   if (nativePattern == 6)
   {
	villageBID = rmCreateGrouping("village B", "double cree village "+villageType);
   }

   if (nativePattern == 7)
   {
	villageBID = rmCreateGrouping("village B", "double cree village "+villageType);
   }

   if (nativePattern == 8)
   {
	villageBID = rmCreateGrouping("village B", "double cree village "+villageType);
   }

   if (nativePattern == 9)
   {
	villageBID = rmCreateGrouping("village B", "double comanche village "+villageType);
   }

   if (nativePattern == 10)
   {
	villageBID = rmCreateGrouping("village B", "double comanche village "+villageType);
   }

   if (nativePattern == 11)
   {
	villageBID = rmCreateGrouping("village B", "double comanche village "+villageType);
   }

   if (nativePattern == 12)
   {
	villageBID = rmCreateGrouping("village B", "double comanche village "+villageType);
   }

   if (nativePattern == 13)
   {
	villageBID = rmCreateGrouping("village B", "double inca village "+villageType);
   }

   if (nativePattern == 14)
   {
	villageBID = rmCreateGrouping("village B", "double maya village "+villageType);
   }

   if (nativePattern == 15)
   {
	villageBID = rmCreateGrouping("village B", "double maya village "+villageType);
   }

   if (nativePattern == 16)
   {
	villageBID = rmCreateGrouping("village B", "double maya village "+villageType);
   }

   if (nativePattern == 17)
   {
	villageBID = rmCreateGrouping("village B", "double tupi village "+villageType);
   }

   rmSetGroupingMinDistance(villageBID, 25.0);
   rmSetGroupingMaxDistance(villageBID, 60.0);
   rmAddGroupingToClass(villageBID, rmClassID("natives"));
   rmAddGroupingToClass(villageBID, rmClassID("importantItem"));
   rmAddGroupingConstraint(villageBID, avoidImpassableLand);
   rmAddGroupingConstraint(villageBID, avoidTradeRoute);
   rmAddGroupingConstraint(villageBID, avoidImportantItem);
   rmAddGroupingConstraint(villageBID, avoidNativesShort);

   // Village C 
   int villageCID = -1;	
   villageType = rmRandInt(1,2);

   if (nativePattern == 0)
   {
	villageCID = rmCreateGrouping("village C", "double aztec village "+villageType);
   }

   if (nativePattern == 1)
   {
	villageCID = rmCreateGrouping("village C", "double nootka village "+villageType);
   }

   if (nativePattern == 2)
   {
 	villageCID = rmCreateGrouping("village C", "double iroquois village "+villageType);
   }

   if (nativePattern == 3)
   {
 	villageCID = rmCreateGrouping("village C", "double iroquois village "+villageType);
   }

   if (nativePattern == 4)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 5)
   {
 	villageCID = rmCreateGrouping("village C", "double iroquois village "+villageType);
   }

   if (nativePattern == 6)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 7)
   {
 	villageCID = rmCreateGrouping("village C", "double iroquois village "+villageType);
   }

   if (nativePattern == 8)
   {
 	villageCID = rmCreateGrouping("village C", "double comanche village "+villageType);
   }

   if (nativePattern == 9)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 10)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 11)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 12)
   {
	villageCID = rmCreateGrouping("village C", "double lakota village "+villageType);  
   }

   if (nativePattern == 13)
   {
	villageCID = rmCreateGrouping("village C", "double maya village "+villageType);
   }

   if (nativePattern == 14)
   {
	villageCID = rmCreateGrouping("village C", "double carib village "+villageType);
   }

   if (nativePattern == 15)
   {
	villageCID = rmCreateGrouping("village C", "double carib village "+villageType);
   }

   if (nativePattern == 16)
   {
	villageCID = rmCreateGrouping("village C", "double tupi village "+villageType);
   }

   if (nativePattern == 17)
   {
	villageCID = rmCreateGrouping("village C", "double carib village "+villageType);
   }

   rmSetGroupingMinDistance(villageCID, 25.0);
   rmSetGroupingMaxDistance(villageCID, 60.0);
   rmAddGroupingToClass(villageCID, rmClassID("natives"));
   rmAddGroupingToClass(villageCID, rmClassID("importantItem"));
   rmAddGroupingConstraint(villageCID, avoidImpassableLand);
   rmAddGroupingConstraint(villageCID, avoidTradeRoute);
   rmAddGroupingConstraint(villageCID, avoidImportantItem);
   rmAddGroupingConstraint(villageCID, avoidNativesShort);

   // place villages for each player
   for(i=1; <cNumberPlayers)
   {           
	rmPlaceGroupingAtLoc(villageAID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
 	rmPlaceGroupingAtLoc(villageBID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceGroupingAtLoc(villageCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // Text
   rmSetStatusText("",0.50);

// Player Nuggets
   int playerNuggetID=rmCreateObjectDef("player nugget");
   rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
   rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(playerNuggetID, 33.0);
   rmSetObjectDefMaxDistance(playerNuggetID, 40.0);
   rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
   rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
   rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
   rmAddObjectDefConstraint(playerNuggetID, avoidWater10);

   for(i=0; <cNumberPlayers)
   {
 	rmSetNuggetDifficulty(1, 1);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Cliffs
   int cliffHt = -1;
   int cliffCoherence = -1;
   cliffCoherence = rmRandFloat(0.4, 0.9);
   int anotherChance = -1;
   anotherChance = rmRandInt(1,2);

   if (makeCliffs == 2)
   {
     if (anotherChance == 1)
        makeCliffs = 1;
     else
        makeCliffs = 0;
   } 

   int failCount=0;
   int numTries=cNumberNonGaiaPlayers*11;

   if (makeCliffs == 1)
   { 
	if (cliffVariety == 6) // for Sonora only
	{
	   // bigger mesas
	   for(i=0; <numTries)
	   {
		int cliffHeight=rmRandInt(0,10);
		int mesaID=rmCreateArea("mesa"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(25), rmAreaTilesToFraction(160)); 
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, "Sonora");
		rmAddAreaToClass(mesaID, rmClassID("canyon"));
		rmAddAreaToClass(mesaID, rmClassID("cliff"));	
		rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
		if (cliffHeight <= 7)
		rmSetAreaCliffHeight(mesaID, rmRandInt(4,10), 1.0, 1.0);
		else
		rmSetAreaCliffHeight(mesaID, -10, 1.0, 1.0);
		rmAddAreaConstraint(mesaID, avoidCanyons);
		rmSetAreaMinBlobs(mesaID, 3);
		rmSetAreaMaxBlobs(mesaID, 5);
		rmSetAreaMinBlobDistance(mesaID, 3.0);
		rmSetAreaMaxBlobDistance(mesaID, 5.0);
		rmSetAreaCoherence(mesaID, 0.5);
		rmAddAreaConstraint(mesaID, playerConstraint); 
		rmAddAreaConstraint(mesaID, avoidSocket);
		rmAddAreaConstraint(mesaID, avoidNativesShort);
		rmAddAreaConstraint(mesaID, avoidWater20);
		rmAddAreaConstraint(mesaID, avoidTradeRoute);
		rmAddAreaConstraint(mesaID, shortAvoidSilver);
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	   }
	   // smaller mesas
	   numTries=cNumberNonGaiaPlayers*13;
	   for(i=0; <numTries)
	   {
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Sonora");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesaID, rmClassID("cliff"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
		rmSetAreaMinBlobs(smallMesaID, 3);
		rmSetAreaMaxBlobs(smallMesaID, 5);
		rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		rmSetAreaCoherence(smallMesaID, 0.3);
		rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidNativesShort); 
		rmAddAreaConstraint(smallMesaID, avoidSocket);
		rmAddAreaConstraint(smallMesaID, avoidWater20);
		rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
		rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	   }
	}
      else // all other maps with cliffs
      {
         int numCliffs = rmRandInt(3,5);
         for (i=0; <numCliffs)
         {
		cliffHt = rmRandInt(5,7);    
		int bigCliffID=rmCreateArea("big cliff" +i);
		rmSetAreaWarnFailure(bigCliffID, false);
		rmSetAreaCliffType(bigCliffID, cliffType);
		rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		if (cliffVariety == 1) // like Patagonia
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(800));
      	   rmSetAreaCliffEdge(bigCliffID, 2, 0.35, 0.1, 1.0, 0);
      	   rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, 7, 2.0, 0.5);
		   rmSetAreaCoherence(bigCliffID, 0.5);
		   rmSetAreaSmoothDistance(bigCliffID, 5);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		else if (cliffVariety == 2) // smaller, kinda like in Sudden Death from AOM
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(280), rmAreaTilesToFraction(400));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		   rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 1.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, cliffCoherence);
		   rmSetAreaSmoothDistance(bigCliffID, 10);
		   rmSetAreaHeightBlend(bigCliffID, 2.0);
		}
		else  // kinda random, kinda like Texas or NE
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(700));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		   rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, cliffCoherence);
		   rmSetAreaSmoothDistance(bigCliffID, 15);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		rmSetAreaMinBlobs(bigCliffID, 3);
		rmSetAreaMaxBlobs(bigCliffID, 5);
		rmSetAreaMinBlobDistance(bigCliffID, 5.0);
		rmSetAreaMaxBlobDistance(bigCliffID, 20.0);
		rmAddAreaConstraint(bigCliffID, avoidImportantItem);
		rmAddAreaConstraint(bigCliffID, avoidTradeRoute);
            rmAddAreaConstraint(bigCliffID, avoidNatives);
	      rmAddAreaConstraint(bigCliffID, avoidWater20);
	      rmAddAreaConstraint(bigCliffID, cliffsAvoidCliffs);
	      rmAddAreaConstraint(bigCliffID, avoidSocket);
	      rmAddAreaConstraint(bigCliffID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliffID, longPlayerConstraint);
		rmBuildArea(bigCliffID);
         }
      }
   }

   // Text
   rmSetStatusText("",0.60);

// Additional central features
   if (patternChance == 8)  // for Rockies
   {
      numTries=2*cNumberNonGaiaPlayers;
      for (i=0; <numTries)
      { 
         int snowForestPatchID = rmCreateArea("snow forest patch"+i, rmAreaID("snow patch"));
         rmAddAreaToClass(snowForestPatchID, rmClassID("classForest"));
         rmSetAreaWarnFailure(snowForestPatchID, false);
         rmSetAreaSize(snowForestPatchID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(120));
         rmSetAreaCoherence(snowForestPatchID, 0.6);
         rmSetAreaForestType(snowForestPatchID, "rockies snow forest");
         rmSetAreaForestDensity(snowForestPatchID, 1.0);
         rmSetAreaForestClumpiness(snowForestPatchID, 0.9);
         rmSetAreaForestUnderbrush(snowForestPatchID, 0.0);
         rmSetAreaCoherence(snowForestPatchID, 0.4);
         rmSetAreaSmoothDistance(snowForestPatchID, 10);
         rmAddAreaToClass(snowForestPatchID, rmClassID("classForest"));
         rmAddAreaConstraint(snowForestPatchID, avoidAll);
         rmAddAreaConstraint(snowForestPatchID, avoidTradeRoute);
	   rmAddAreaConstraint(snowForestPatchID, avoidSocket);
         rmBuildArea(snowForestPatchID);
      }       
   }

// Random Nuggets
   int nuggetID= rmCreateObjectDef("nugget"); 
   rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
   rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nuggetID, 45.0);
   rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.4));
   rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nuggetID, avoidNugget);
   rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
   rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(nuggetID, avoidSocket);
   rmAddObjectDefConstraint(nuggetID, avoidAll);
   rmAddObjectDefConstraint(nuggetID, circleConstraint);
   rmAddObjectDefConstraint(nuggetID, avoidWater20);

   for(i=1; <cNumberPlayers)
   {
      rmSetNuggetDifficulty(2, 2);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmSetNuggetDifficulty(3, 3);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

   // Text
   rmSetStatusText("",0.65);

// more resources 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 12);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false, 3);

   int berryNum = rmRandInt(2,5);
   int StartBerryBushID=rmCreateObjectDef("starting berry bush");
   rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
   rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
   if  (placeBerries == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);

   int deerNum = rmRandInt(4, 6);
   int startPronghornID=rmCreateObjectDef("starting pronghorn");
   rmAddObjectDefItem(startPronghornID, deerType, deerNum, 4.0);
   rmAddObjectDefToClass(startPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(startPronghornID, 15);
   rmSetObjectDefMaxDistance(startPronghornID, 22);
   rmAddObjectDefConstraint(startPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(startPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(startPronghornID, true);
   rmPlaceObjectDefPerPlayer(startPronghornID, false, 1);

   int deer2Num = rmRandInt(4, 7);
   int farPronghornID=rmCreateObjectDef("far pronghorn");
   rmAddObjectDefItem(farPronghornID, deer2Type, deer2Num, 4.0);
   rmAddObjectDefToClass(farPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farPronghornID, 40.0);
   rmSetObjectDefMaxDistance(farPronghornID, 65.0);
   rmAddObjectDefConstraint(farPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(farPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(farPronghornID, huntableConstraint);
   rmAddObjectDefConstraint(farPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(farPronghornID, true);
   if (sheepChance == 0)
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

// Silver mines - players
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(playerGoldID, circleConstraint);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, avoidWater20);
   rmSetObjectDefMinDistance(playerGoldID, 25.0);
   rmSetObjectDefMaxDistance(playerGoldID, 30.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldMediumID, circleConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater10);
   rmSetObjectDefMinDistance(GoldMediumID, 50.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 70.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);

// Extra silver mines in the middle and near ends of axis.
   silverType = rmRandInt(1,10);
   int extraGoldID = rmCreateObjectDef("extra silver "+i);
   rmAddObjectDefItem(extraGoldID, "mine", 1, 0.0);
   rmAddObjectDefToClass(extraGoldID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(extraGoldID, avoidCliffs);
   rmAddObjectDefConstraint(extraGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraGoldID, avoidWater10);
   rmAddObjectDefConstraint(extraGoldID, avoidAll);
   rmSetObjectDefMinDistance(extraGoldID, 0.0);
   rmSetObjectDefMaxDistance(extraGoldID, 60.0);
   rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.5, rmRandInt(2, 3));
   if (cNumberNonGaiaPlayers > 4)
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.5, 1);
   if (cNumberNonGaiaPlayers > 6)
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.5, 1);
   if (axisChance == 1)
   {
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.2, 1);
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.5, 0.8, 1);
   }
   else
   {
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.8, 0.5, 1);
      rmPlaceObjectDefAtLoc(extraGoldID, 0, 0.2, 0.5, 1);
   }

   // Text
   rmSetStatusText("",0.70);

// sheep etc
   if (sheepChance == 1)
   {
      int sheepID=rmCreateObjectDef("herdable animal");
      rmAddObjectDefItem(sheepID, sheepType, 2, 4.0);
      rmSetObjectDefMinDistance(sheepID, 35.0);
      rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
      rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheepID, avoidSheep);
      rmAddObjectDefConstraint(sheepID, avoidAll);
      rmAddObjectDefConstraint(sheepID, playerConstraint);
      rmAddObjectDefConstraint(sheepID, avoidCliffs);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
   }

// Central herds
   int centralHerdID=rmCreateObjectDef("central herd");  
   rmAddObjectDefItem(centralHerdID, centerHerdType, rmRandInt(7,9), 6.0);
   rmAddObjectDefToClass(centralHerdID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(centralHerdID, rmXFractionToMeters(0.28));
   rmSetObjectDefMaxDistance(centralHerdID, rmXFractionToMeters(0.35));
   rmAddObjectDefConstraint(centralHerdID, avoidTradeRoute);
   rmAddObjectDefConstraint(centralHerdID, avoidImportantItem);
   rmAddObjectDefConstraint(centralHerdID, avoidWater10);
   rmAddObjectDefConstraint(centralHerdID, longPlayerConstraint);
   rmAddObjectDefConstraint(centralHerdID, huntableConstraint);
   rmSetObjectDefCreateHerd(centralHerdID, true);
   rmPlaceObjectDefPerPlayer(centralHerdID, false, 2);

// forest
   numTries=12*cNumberNonGaiaPlayers;
   if (cNumberNonGaiaPlayers == 3)
      numTries=11*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 3)
      numTries=10*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 5)
      numTries=9*cNumberNonGaiaPlayers;  
   failCount=0;

   int forDensity = rmRandFloat(0.8, 1.0);
   int forClumpiness = rmRandFloat(0.5, 0.9);
   int forCoherence = rmRandFloat(0.4, 0.7);
   int forChance = rmRandInt(1, 2);
   int forUnderBrush = rmRandFloat(0.0, 0.5);
   int forHt = -1;

   for (i=0; <numTries)
   {
      forHt = rmRandFloat(2.0, 4.0);  
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(160), rmAreaTilesToFraction(210));
      rmSetAreaForestType(forest, forestType);
      rmSetAreaForestDensity(forest, forDensity);
      rmSetAreaForestClumpiness(forest, forClumpiness);
      if (patternChance == 7)
         rmSetAreaForestUnderbrush(forest, 0.0);
	else
         rmSetAreaForestUnderbrush(forest, forUnderBrush);
      rmSetAreaCoherence(forest, forCoherence);
      if (forChance == 2)
      {
		rmSetAreaMinBlobs(forest, 1);
		rmSetAreaMaxBlobs(forest, 3);					
		rmSetAreaMinBlobDistance(forest, 12.0);
		rmSetAreaMaxBlobDistance(forest, 24.0);
	}
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidStartingUnits);
	rmAddAreaConstraint(forest, avoidSocket);
      rmAddAreaConstraint(forest, forestsAvoidBison); 
	rmAddAreaConstraint(forest, hillConstraint);
	if (hillTrees == 1)
         rmSetAreaBaseHeight(forest, forHt);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   } 

   // Text
   rmSetStatusText("",0.80);

// Random trees
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, treeType, 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmAddObjectDefConstraint(StragglerTreeID, avoidStartingUnitsSmall);
   rmAddAreaConstraint(StragglerTreeID, hillConstraint);
   rmAddAreaConstraint(StragglerTreeID, patchConstraint);
   rmAddObjectDefConstraint(StragglerTreeID, avoidWater10);
   rmSetObjectDefMinDistance(StragglerTreeID, 10.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <cNumberNonGaiaPlayers*8)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);

// Extra tree clumps near players - to ensure fair access to wood
   int extraTreesID=rmCreateObjectDef("extra trees");
   rmAddObjectDefItem(extraTreesID, treeType, 4, 5.0);
   rmSetObjectDefMinDistance(extraTreesID, 17);
   rmSetObjectDefMaxDistance(extraTreesID, 20);
   rmAddObjectDefConstraint(extraTreesID, avoidAll);
   rmAddObjectDefConstraint(extraTreesID, avoidResource);
   rmAddObjectDefConstraint(extraTreesID, avoidImpassableLand);
   rmAddObjectDefConstraint(extraTreesID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraTreesID, avoidWater10);
   rmAddObjectDefConstraint(extraTreesID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(extraTreesID, avoidNativesShort);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTreesID, 0, rmAreaID("player"+i), 2);

   // Text
   rmSetStatusText("",0.90);

// Deco
   if (patternChance == 1)
   {
	int randomWaterTreeID=rmCreateObjectDef("random tree in water");
	rmAddObjectDefItem(randomWaterTreeID, "treeBayouMarsh", 1, 0.0);
	rmSetObjectDefMinDistance(randomWaterTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomWaterTreeID, rmXFractionToMeters(0.1));
	rmPlaceObjectDefInArea(randomWaterTreeID, 0, smalllakeID, rmRandInt(3,6)); 

	int randomTurtlesID=rmCreateObjectDef("random turtles in water");
	rmAddObjectDefItem(randomTurtlesID, "propTurtles", 1, 3.0);
	rmSetObjectDefMinDistance(randomTurtlesID, 0.0);
	rmSetObjectDefMaxDistance(randomTurtlesID, rmXFractionToMeters(0.1));
	rmAddObjectDefConstraint(randomTurtlesID, nearShore);

	int randomWaterRocksID=rmCreateObjectDef("random rocks in water");
	rmAddObjectDefItem(randomWaterRocksID, "underbrushLake", rmRandInt(1,3), 3.0);
	rmSetObjectDefMinDistance(randomWaterRocksID, 0.0);
	rmSetObjectDefMaxDistance(randomWaterRocksID, rmXFractionToMeters(0.1));

	int randomDucksID=rmCreateObjectDef("random ducks in water");
	rmAddObjectDefItem(randomDucksID, "DuckFamily", 1, 0.0);
	rmSetObjectDefMinDistance(randomDucksID, 0.0);
	rmSetObjectDefMaxDistance(randomDucksID, rmXFractionToMeters(0.1));
	rmAddObjectDefConstraint(randomDucksID, avoidDucks);

	rmPlaceObjectDefInArea(randomTurtlesID, 0, smalllakeID, rmRandInt(1,2)); 
	rmPlaceObjectDefInArea(randomWaterRocksID, 0, smalllakeID, rmRandInt(1,2)); 
	rmPlaceObjectDefInArea(randomDucksID, 0, smalllakeID, rmRandInt(1,2)); 
   }

   if (patternChance == 6)
   {
      int coastalRockID=rmCreateObjectDef("coastal rocks");
      rmAddObjectDefItem(coastalRockID, "coastalRocksSaguenay", 1, 0.0);
      rmSetObjectDefMinDistance(coastalRockID, 0.0);
      rmSetObjectDefMaxDistance(coastalRockID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(coastalRockID, rockVsLand);
	rmAddObjectDefConstraint(coastalRockID, nearShore);
      rmAddObjectDefConstraint(coastalRockID, avoidStartingUnits);
      rmPlaceObjectDefAtLoc(coastalRockID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
   }

   if (patternChance == 12)
   {
	int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 45.0);
	rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	rmSetObjectDefMaxDistance(bigDecorationID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bigDecorationID, avoidAll);
	rmAddObjectDefConstraint(bigDecorationID, avoidImportantItem);
	rmAddObjectDefConstraint(bigDecorationID, avoidCoin);
	rmAddObjectDefConstraint(bigDecorationID, avoidImpassableLand);
	rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	rmAddObjectDefConstraint(bigDecorationID, avoidCliffs);
	rmAddObjectDefConstraint(bigDecorationID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.5, 2);
   }

   if (plainsMap == 1)
   {
	int areThereBuffalo=rmRandInt(1, 2);
	int howManyBuffalo=rmRandInt(2, 3);
	if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("Bison Carcass", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidStartingUnits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidNuggetSmall);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	}

	int grassPatchGroupType=-1;
	int grassPatchGroup=-1;

	for(i=1; <12*cNumberNonGaiaPlayers)
      {
		grassPatchGroupType=rmRandInt(1, 7);
		grassPatchGroup=rmCreateGrouping("Grass Patch Group"+i, "gp_grasspatch0"+grassPatchGroupType);
		rmSetGroupingMinDistance(grassPatchGroup, 0.0);
		rmSetGroupingMaxDistance(grassPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(grassPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(grassPatchGroup, playerConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(grassPatchGroup, avoidSocket);
		rmAddGroupingConstraint(grassPatchGroup, avoidNatives);
		rmAddGroupingConstraint(grassPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(grassPatchGroup, circleConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidStartingUnits);
		rmAddGroupingConstraint(grassPatchGroup, avoidAll);
		rmAddGroupingConstraint(grassPatchGroup, avoidCliffs);
		rmPlaceGroupingAtLoc(grassPatchGroup, 0, 0.5, 0.5, 1);
	}

	int flowerPatchGroupType=-1;
	int flowerPatchGroup=-1;

	for(i=1; <12*cNumberNonGaiaPlayers)
      {
		flowerPatchGroupType=rmRandInt(1, 8);
		flowerPatchGroup=rmCreateGrouping("Flower Patch Group"+i, "gp_flower0"+flowerPatchGroupType);
		rmSetGroupingMinDistance(flowerPatchGroup, 0.0);
		rmSetGroupingMaxDistance(flowerPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(flowerPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(flowerPatchGroup, playerConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(flowerPatchGroup, avoidSocket);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNatives);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(flowerPatchGroup, avoidAll);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCliffs);
		rmAddGroupingConstraint(flowerPatchGroup, circleConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidStartingUnits);
		rmPlaceGroupingAtLoc(flowerPatchGroup, 0, 0.5, 0.5, 1);
	}
   }

   if (vultures == 1)
   { 
	int vultureID=rmCreateObjectDef("perching vultures");
	int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	rmSetObjectDefMinDistance(vultureID, 0.0);
	rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(vultureID, avoidAll);
	rmAddObjectDefConstraint(vultureID, avoidImportantItem);
	rmAddObjectDefConstraint(vultureID, avoidCoin);
	rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	rmAddObjectDefConstraint(vultureID, avoidCliffs);
	rmAddObjectDefConstraint(vultureID, avoidVultures);
	rmAddObjectDefConstraint(vultureID, avoidWater20);
	rmAddObjectDefConstraint(vultureID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);
   }

   if (eagles == 1)
   {
	int avoidEagles=rmCreateTypeDistanceConstraint("avoids Eagles", "EaglesNest", 40.0);
	int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
	rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
	rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomEagleTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAll);
	rmAddObjectDefConstraint(randomEagleTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomEagleTreeID, avoidEagles);
	rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 3);
   }

   if (patternChance == 13) // Sonora
   {
	int buzzardFlockID=rmCreateObjectDef("buzzards");
	int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	rmAddObjectDefItem(buzzardFlockID, "BuzzardFlock", 1, 3.0);
	rmSetObjectDefMinDistance(buzzardFlockID, 0.0);
	rmSetObjectDefMaxDistance(buzzardFlockID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(buzzardFlockID, avoidBuzzards);
	rmAddObjectDefConstraint(buzzardFlockID, avoidSocket);
	rmAddObjectDefConstraint(buzzardFlockID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(buzzardFlockID, playerConstraint);
	rmPlaceObjectDefAtLoc(buzzardFlockID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
   }

   if (patternChance == 4) // GL
   {
	int avoidGrass=rmCreateTypeDistanceConstraint("avoids grass", "underbrushTexasGrass", 30.0);
   	int Grass=rmCreateObjectDef("grass");
	rmAddObjectDefItem(Grass, "underbrushTexasGrass", 1, 0.0);
	rmSetObjectDefMinDistance(Grass, 0.0);
	rmSetObjectDefMaxDistance(Grass, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(Grass, avoidAll);
	rmAddObjectDefConstraint(Grass, avoidImpassableLand);
	rmAddObjectDefConstraint(Grass, playerConstraint);
	rmPlaceObjectDefAtLoc(Grass, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
   }
   
   if (patternChance == 17) // Pampas
   {
	int avoidBrush=rmCreateTypeDistanceConstraint("avoids brush", "UnderbrushPampas", 30.0);
	int decoUnderbrushID=rmCreateObjectDef("underbrush");
	rmAddObjectDefItem(decoUnderbrushID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	rmSetObjectDefMinDistance(decoUnderbrushID, 20.0);
	rmSetObjectDefMaxDistance(decoUnderbrushID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(decoUnderbrushID, avoidAll);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidImpassableLand);
	rmAddObjectDefConstraint(decoUnderbrushID, playerConstraint);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidBrush);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidTradeRoute);
      rmPlaceObjectDefAtLoc(decoUnderbrushID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
   }
}  
